#include "user_conf.h"
#include "ukui_login_sound.h"
#include <QDebug>
#include <QString>
#include <QCoreApplication>
#include <QFile>
#include <ukui-log4qt.h>
#include <QDir>
#include <syslog.h>

//开机音乐播放路径
#define PLAY_STARTUP_WAV "/usr/share/ukui/ukui-session-manager/startup.wav"
//默认音频设备
#define DEFAULT_AUDIO_DEV   "default"
//声卡存放文件
#define AUDIO_JSON  "/.config/audio.json"
//开机按钮选项
#define IS_STARTUP_PLAY_JSON  "/.config/startupMusic.json"

int main(int argc, char *argv[])
{
//    initUkuiLog4qt("ukui-login-sound");

    QCoreApplication a(argc, argv);

    //配置信息：设备、用户
    UserConf info;

    //播放开机音乐
    UkuiLoginSound playback;

    QFile file("/tmp/PlayStartupWav.json");
    if(!file.exists())
    {
        syslog (LOG_INFO, "start up");
        syslog (LOG_INFO, "create /tmp/PlayStartupWav.json");
        info.insertJson();

        if((info.readLightdmConf()=="")&&(info.readLastUser()==""))
        {
            //1、装机第一次登录的情况，使用默认设备进行播放
            syslog (LOG_INFO, "1 First enter");
            playback.aplayMain(2,PLAY_STARTUP_WAV,DEFAULT_AUDIO_DEV);
        }else
        {
            QString userFilePath = "/home/";
            QString audioDEV = "default";

            //判断用户是否开启开机音乐
                if(info.readLightdmConf()!="")
                {
                    //2、存在自动登录用户的情况下，使用自动登录用户的设备进行播放
                    userFilePath += info.readLightdmConf();
                    audioDEV =info.readJson(userFilePath,AUDIO_JSON,"card");
                    syslog (LOG_INFO, "2 user.readLightdmConf()!=null audioDEV:%s  userFilePath:%s",audioDEV,userFilePath);
                }
                else if(info.readLastUser()!="")
                {
                    //3、没有自动登录用户的时候,使用上一次用户的播放设备
                    userFilePath += info.readLastUser();
                    audioDEV =info.readJson(userFilePath,AUDIO_JSON,"card");
                    syslog (LOG_INFO, "3 user.readLastUser()!="" audioDEV: %s  readLastUserFile:%s",audioDEV,userFilePath);
                }

            QString StartupState = info.readJson(userFilePath,IS_STARTUP_PLAY_JSON,"startupPlayMusic");
            syslog (LOG_INFO," StartupState %s  %s  %s",StartupState,userFilePath,audioDEV);
            if(StartupState == "true")
                playback.aplayMain(2,PLAY_STARTUP_WAV,audioDEV.toLatin1().data());

        }
    }
    else{
        syslog (LOG_INFO, "not first enter,so will not play startup.wav");
    }
    file.close();
    return 0;
}

